int main(int argc,char* argv[])
{
  // initialize the ORB
  CORBAContext::instance(argc,argv);

  // use the logger
  try
    {
    Logger logger;
    logger.logMessage(Logger::LOW,
                      "An unimportant test message.");
    logger.logMessage(Logger::MEDIUM,
                      __FILE__,
                      __LINE__,
                      "A semi-important test message.");
    logger.logMessage(Logger::HIGH,
                      "ClassName",
                      "methodName",
                      "A very important test message.");

    cout << argv[0] << ":  MEDIUM level messages:" << endl;
    vector<string,allocator> messages = logger.messages(Logger::MEDIUM);
    for (vector<string,allocator>::iterator it = messages.begin();
         it != messages.end();
         it++)
      cout << (*it) << endl;
    }
  catch (string& e)
    {
    cerr << argv[0] << ":  exception raised by Logger:  "
         << e << endl;
    }
}  // end main
