// Copyright (c) 1996-2000 by Vladimir Batov. Permission to  use,
// copy, modify,  distribute  and  sell  this  software  and  its
// documentation for any purpose is hereby granted  without  fee,
// provided that the above copyright notice appear in all  copies
// and that both that copyright notice and this permission notice
// appear in supporting documentation. I make no  representations
// about the suitability of this software for any purpose. It  is
// provided "as is" without express or implied warranty.

#ifndef VB_SIGNAL_EVENT_H
#define VB_SIGNAL_EVENT_H

namespace SignalNamespace {

class Event
{
   public: 

   virtual ~Event () {}

   bool
   operator==(const Event& event) const
   {
      return memcmp(this, &event, sizeof(Event)) == 0;
   }

   virtual const char* name() const
   {
      // The function exists purely for debugging purposes.
      return "Event";
   }
};
   
} // End of SignalNamespace

#endif
